@echo off

echo VMware Documentation Downloader
echo -------------------------------
echo.
echo %~n0%~x0 v9.07.13
echo Paul Buckle, www.xtravirt.com
echo.


REM Requires a Win32 port of wget.exe in the same directory (such as from http://users.ugent.be/~bpuype/wget)


REM Define the input and output files.
set INPUT_FILE=%~n0.inp
set OUTPUT_FILE=%~n0.txt


REM Create the input file.
REM The HTML pages and PDF files linked to from each of the following VMware web pages will be downloaded.
REM The last entry is the one that will be opened in the web browser, so should be the index page.
REM For this reason, the input file needs to be created even if the download is not elected to be performed.
REM Links on "VMware Documentation" page at www.vmware.com/support/pubs/index.html:
echo http://www.vmware.com/support/pubs/vs_pages/vsp_pubs_esxi40_e_vc40.html > %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vs_pages/vsp_pubs_esxi40_i_vc40.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vs_pages/vsp_pubs_esx40_vc40.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vi_pages/vi_pubs_35u2_3i_e.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vi_pages/vi_pubs_35_3i_e.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vi_pages/vi_pubs_35u2_3i_i.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vi_pages/vi_pubs_35_3i_i.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vi_pages/vi_pubs_35u2.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vi_pages/vi_pubs_35.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vi_pages/vi_pubs_302_301.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vi_pages/vi_pubs_30.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/srm_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vdr_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/labmanager_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/lcm_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/stagemanager_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/heartbeat_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/appspeed_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vcbm_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vsz_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/converter_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/server_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/developer/vima/index.html >> %INPUT_FILE%
echo http://www.vmware.com/support/developer/vcli/index.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/orchestrator_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/developer/windowstoolkit/index.html >> %INPUT_FILE%
echo http://www.vmware.com/support/developer/ps-libs/vumps/index.html >> %INPUT_FILE%
echo http://www.vmware.com/support/developer/vc-sdk/index.html >> %INPUT_FILE%
echo http://www.vmware.com/support/developer/cim-sdk/index.html >> %INPUT_FILE%
echo http://www.vmware.com/support/developer/viperltoolkit/index.html >> %INPUT_FILE%
echo http://www.vmware.com/support/developer/studio/index.html >> %INPUT_FILE%
echo http://www.vmware.com/support/developer/ovf/index.html >> %INPUT_FILE%
echo http://www.vmware.com/support/developer/vddk/index.html >> %INPUT_FILE%
echo http://www.vmware.com/support/developer/vix-api/index.html >> %INPUT_FILE%
echo http://www.vmware.com/support/developer/vmci-sdk/index.html >> %INPUT_FILE%
echo http://www.vmware.com/support/developer/guest-sdk/index.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/view_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vdi_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/ws_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/ace_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/player_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/fusion_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/thinapp_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/esx_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vc_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/gsx_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vmimporter_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/p2v_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/developer/prog-api/index.html >> %INPUT_FILE%
echo http://www.vmware.com/support/developer/scripting-API/index.html >> %INPUT_FILE%
REM Links on "VMware vSphere 4" page at www.vmware.com/support/pubs/vs_pages/vsp_pubs_esx40_vc40.html:
echo http://www.vmware.com/support/pubs/vum_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vcc_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/vcb_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/admin_auto_pubs.html >> %INPUT_FILE%
echo http://www.vmware.com/support/pubs/sdk_pubs.html >> %INPUT_FILE%
REM Links on "VMware Administration Automation Products Documentation" page at www.vmware.com/support/pubs/vs_pages/vsp_pubs_esx40_vc40.html:
echo http://www.vmware.com/support/pubs/ps_pubs.html >> %INPUT_FILE%
REM Link for main index page:
echo http://www.vmware.com/support/pubs/index.html >> %INPUT_FILE%


REM If a log file exists, the date/time stamp on it will indicate when the batch file was last run.
REM Present this information to assist the decision of whether an update should be performed or not.
echo.
echo The last check for updates was:
echo.
if exist %OUTPUT_FILE% (
	for /f %%A in ("%OUTPUT_FILE%") do echo %%~tA
) else (
	echo Never
)


REM Prompt if a check should be made for updates.
REM If a previous logfile does not exist, assume that nothing has been downloaded yet.
REM In this situation, don't prompt and just go ahead with the download.
if not exist %OUTPUT_FILE% goto DOWNLOAD
echo.
set /p UPDATE=Check for updates before viewing? ^<y/n^>: 
if not %UPDATE%==y goto LAUNCH


REM Download the required files. If this has been done previously, only new or updated files will be downloaded.
:DOWNLOAD
echo.
set /p PROXY=Enter any HTTP proxy details in the form [[user:password@]proxy:port]: 
if not empty%PROXY%==empty set PROXY=-e http_proxy=%PROXY% -e https_proxy=%PROXY% -e ftp_proxy=%PROXY%

echo.
echo Checking for updates...
wget.exe --convert-links --timestamping --page-requisites --recursive --level=1 --input-file=%INPUT_FILE% --output-file=%OUTPUT_FILE% --accept=pdf,htm,html,php --no-check-certificate %PROXY%

find /i "pdf' saved" %OUTPUT_FILE% > nul
if errorlevel 1 goto NOUPDATES

echo.
echo The following updates were downloaded:
echo.
for /f "tokens=6" %%A in ('type %OUTPUT_FILE% ^| find /i "pdf' saved"') do (
echo Downloaded %%A >> %OUTPUT_FILE%
echo %%A
)

goto REVIEW


:NOUPDATES
echo.
echo No updates were found.


:REVIEW
echo.
set /p REVIEW=Review the log file? ^<y/n^> : 
if %REVIEW%==y start %OUTPUT_FILE%


:LAUNCH
for /f "delims=/ tokens=1*" %%A in (%INPUT_FILE%) do set OPEN_PAGE=%%B
start %OPEN_PAGE%
del %INPUT_FILE%